"""autogenerated by genpy from saphari_msgs/BodyPart.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class BodyPart(genpy.Message):
  _md5sum = "f97d66c4403cdacb1c743e356fc26b62"
  _type = "saphari_msgs/BodyPart"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint8 LEFTFOOT=0
uint8 LEFTLEG=1
uint8 LEFTKNEE=2
uint8 LEFTTHIGH=3
uint8 RIGHTFOOT=4
uint8 RIGHTLEG=5
uint8 RIGHTKNEE=6
uint8 RIGHTTHIGH=7
uint8 RIGHTHIP=8
uint8 LEFTHIP=9
uint8 NECK=10
uint8 RIGHTARM=11
uint8 RIGHTELBOW=12
uint8 RIGHTFOREARM=13
uint8 RIGHTHAND=14
uint8 LEFTARM=15
uint8 LEFTELBOW=16
uint8 FOREARM=17
uint8 LEFTHAND=18
uint8 LEFTBOTTOMFACE=19
uint8 RIGHTBOTTOMFACE=20
uint8 LEFTTOPFACE=21
uint8 RIGHTTOPFACE=22
uint8 RIGHTCHEST=23
uint8 LEFTCHEST=24

#following ids are the backup for the demo using the ni tracker
uint8 HEAD=96
uint8 TORSO=97
uint8 RIGHTSHOULDER=98
uint8 LEFTSHOULDER=99

int32 id
int32 label
int32[] childIDs
geometry_msgs/Point32 centroid
float32 radius

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"""
  # Pseudo-constants
  LEFTFOOT = 0
  LEFTLEG = 1
  LEFTKNEE = 2
  LEFTTHIGH = 3
  RIGHTFOOT = 4
  RIGHTLEG = 5
  RIGHTKNEE = 6
  RIGHTTHIGH = 7
  RIGHTHIP = 8
  LEFTHIP = 9
  NECK = 10
  RIGHTARM = 11
  RIGHTELBOW = 12
  RIGHTFOREARM = 13
  RIGHTHAND = 14
  LEFTARM = 15
  LEFTELBOW = 16
  FOREARM = 17
  LEFTHAND = 18
  LEFTBOTTOMFACE = 19
  RIGHTBOTTOMFACE = 20
  LEFTTOPFACE = 21
  RIGHTTOPFACE = 22
  RIGHTCHEST = 23
  LEFTCHEST = 24
  HEAD = 96
  TORSO = 97
  RIGHTSHOULDER = 98
  LEFTSHOULDER = 99

  __slots__ = ['id','label','childIDs','centroid','radius']
  _slot_types = ['int32','int32','int32[]','geometry_msgs/Point32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       id,label,childIDs,centroid,radius

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(BodyPart, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = 0
      if self.label is None:
        self.label = 0
      if self.childIDs is None:
        self.childIDs = []
      if self.centroid is None:
        self.centroid = geometry_msgs.msg.Point32()
      if self.radius is None:
        self.radius = 0.
    else:
      self.id = 0
      self.label = 0
      self.childIDs = []
      self.centroid = geometry_msgs.msg.Point32()
      self.radius = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2i.pack(_x.id, _x.label))
      length = len(self.childIDs)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.childIDs))
      _x = self
      buff.write(_struct_4f.pack(_x.centroid.x, _x.centroid.y, _x.centroid.z, _x.radius))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.centroid is None:
        self.centroid = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.id, _x.label,) = _struct_2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.childIDs = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 16
      (_x.centroid.x, _x.centroid.y, _x.centroid.z, _x.radius,) = _struct_4f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2i.pack(_x.id, _x.label))
      length = len(self.childIDs)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.childIDs.tostring())
      _x = self
      buff.write(_struct_4f.pack(_x.centroid.x, _x.centroid.y, _x.centroid.z, _x.radius))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.centroid is None:
        self.centroid = geometry_msgs.msg.Point32()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.id, _x.label,) = _struct_2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.childIDs = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      _x = self
      start = end
      end += 16
      (_x.centroid.x, _x.centroid.y, _x.centroid.z, _x.radius,) = _struct_4f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_4f = struct.Struct("<4f")
_struct_2i = struct.Struct("<2i")
